/*
 * Esempi su puntatori e array
 * Lab. di Sistemi Operativi - AA 2010-11
 * Franco Alberto Cardillo - cardillo@di.unipi.it
 * 
 * NOTA: Il placemark *p stampa il valore (indirizzo della cella) 
 * di un puntatore di tipo void*.
 */

#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>

/* Dichiarazione delle funzioni */
void print_int_array(int *a, int length);

int main() {
  int a[3];
  int *p;
  unsigned long p_val1, p_val2;
  size_t size_p, size_int;
 
  a[0] = 1;
  a[1] = 2;
  a[2] = 3;
  /* int a[3] = {1, 2, 3} */

  p = &a[0];
  printf("p=&a[0]... *p=%d\t*(p+1)=%d\t*(p+2)=%d\n", *p, *(p+1), *(p+2));
  /* Nota: *p+1 non e` equivalente a *(p+1) */
  
  printf("\n---\n\n");
  
  p = a;
  printf("p=a... *p=%d\t*(p+1)=%d\t*(p+2)=%d\n", *p, *(p+1), *(p+2));
  
  printf("\n---\n\n");
  
  /* Incrementiamo p */
  printf("*p=%d\t", *p);
  p = p+1;
  printf("*p=%d\t", *p);
  p++;
  printf("*p=%d\n", *p);
  
  printf("\n---\n\n");

  /* Il compilatore traduce a[i] in *(a+i) */
  printf("*a=%d\t*(a+1)=%d\t*(a+2)=%d\n", *a, *(a+1), *(a+2));
  
  
  printf("\n---\n\n");

  /* 
   * L'istruzione seguente causerebbe un errore di compilazione.
   *
   * a = a + 1;
   *
   * Se passiamo l'array a ad una funzione, all'interno della funzione
   * l'array sara` una normale variabile puntatore - che potremo quindi
   * incrementare, decrementare ecc.
  */
  print_int_array(a, 3);
  
  print_int_array(&a[1], 2);
  
  printf("\n---\n\n");

  p = &a[1];
  printf("*p=%d\t*(p-1)=%d\n", *p, *(p-1));

  /*
   * Aritmetica degli indirizzi
   *
   * Se *p e` un puntatore ad un elemento di un array, p + 1 punta all'elemento successivo.
   * E` il compilatore a decidere di quanto incrementare p IN BASE AL TIPO DEGLI ELEMENTI DELL'ARRAY
   */
  
  printf("\n---\n\n");
  
  /* WARNING: Il codice che segue e` errato [puntatori e differenze tra puntatori visti come long int] */
  p = a;
  printf("p=%p \t p+1=%p \n", (void*) p, (void*) (p+1));
  printf("(p+1) - p = %p\n", (void*) ((p+1)-p));
  
  p_val1 = (unsigned long) p;
  p_val2 = (unsigned long) (p+1);
  printf("p=%lu, p+1=%lu, (p+1)-p=%lu\n", p_val1, p_val2, p_val2-p_val1);
  
  /* sizeof restituisce un size_t, K&R: intero privo di segno, QUI: unsigned long */
  size_p = sizeof(*p);
  size_int = sizeof(int);
  
  /* C90: size_t puo` essere stampato con %zu */
  printf("\nPerche'? sizeof(*p)=%lu \t\t sizeof(int)=%lu\n", size_p, size_int);
  
  
  /* EXIT WITH SUCCESS */
  return EXIT_SUCCESS;
} /* main */


void print_int_array(int *a, int length) {
  int i=0;
  for(i=0; i<length; i++, a++) {
    printf("a[%d]=%d", i, *a);
    
    printf( (i==length-1)? "\n":"\t\t");
  } /* for */
} /* print_int_array */
