/*
 * Esempi sui puntatori
 * Lab. di Sistemi Operativi - AA 2010-11
 * Franco Alberto Cardillo - cardillo@di.unipi.it
 * 
 * NOTA: Il placemark *p stampa il valore (indirizzo della cella) 
 * di un puntatore di tipo void*.
 */

#include <stdio.h>
#include <stdlib.h>


/* Dichiarazione delle funzioni */
void swap_v(int x, int y);
void swap(int* p, int* q);
void swap2(int* p, int* q);
void swap_p(int* p, int* q);

void c_pointer_fun(const int* p);
void modify_pointer(int *p);

int main() {
  int a=0; int b=1;

  /* Passaggio dei parametri PER VALORE */
  printf("[pre] swap_v, a=%d, b=%d\n", a, b);
  swap_v(a, b);
  printf("[post] swap_v, a=%d, b=%d\n", a, b);

  printf("***\n");
  
  /* Passaggio dei parametri PER RIFERIMENTO */
  printf("[pre] swap, a=%d, b=%d\n", a, b);
  swap(&a, &b);
  printf("[post] swap, a=%d, b=%d\n", a, b);
  
  printf("---\n");
    
  printf("[Prima di swap2] int a. Indirizzo: %p  -- Valore: %d\n", (void *) &a, a);
  printf("[Prima di swap2] int b. Indirizzo: %p  -- Valore: %d\n", (void *) &b, b);
  swap2(&a, &b);
  printf("[Dopo swap2] int a. Indirizzo: %p  -- Valore: %d\n", (void *) &a, a);
  printf("[Dopo swap2] int b. Indirizzo: %p  -- Valore: %d\n", (void *) &b, b);
  
  /*printf("---\n");
  a = 0; b = 1;
  printf("Prima di swap_p: a=%d, b=%d\n", a, b);
  swap_p(&a, &b);
  printf("Dopo swap_p: a=%d, b=%d -- Risultato atteso (a=1,b=0)\n", a, b);*/

  printf("---\n");
  a = 111;
  c_pointer_fun(&a);
  printf("a = %d\n", a);

  return EXIT_SUCCESS;
} /* int main */


/* swap_v: ERRATA */
void swap_v(int x, int y) {
  int tmp;
  tmp = x;
  x = y;
  y = tmp;
} /* swap_v */

/* swap: CORRETTA */
void swap(int* p, int* q) {
  int tmp = 0;
  
  /* assegnamno a tmp il valore della cella di memoria "puntata da p" */
  tmp = *p;
  
  /* scriviamo nella cella puntata da p il valore della cella "puntata da q" */
  *p = *q;
  
  /* scriviamo nella cella "puntata da q" il valore di tmp */
  *q = tmp;
} /* swap */


/* swap2: come swap, ma stampa due messaggi */
void swap2(int* p, int* q) {
  int tmp = 0;
  printf("\t[all'interno di swap2] int* p. Indirizzo: %p  -- Valore: %p -- Valore 'puntato': %d \n", (void*) &p, (void*) p, *p);
  printf("\t[all'interno di swap2] int* q. Indirizzo: %p  -- Valore: %p -- Valore 'puntato': %d \n", (void*) &q, (void*)q, *q);
  tmp = *p;
  *p = *q;
  *q = tmp;
} /* swap2 */


/* swap_p: ERRATA */
void swap_p(int *p, int* q) {
  /* Proviamo a scambiare non i valori, ma gli indirizzi delle celle di memoria "puntate" */
  int* tmp = NULL;
  printf("\t[swap_p] Prima dello scambio. *p=%d, *q=%d\n", *p, *q);
  
  /* Memorizzo in tmp l'indirizzo della cella puntata da p */
  tmp = p;

  /* Scambio gli indirizzi cui p e q puntano */
  p = q;
  q = tmp;
  printf("\t[swap_p] Dopo lo scambio. *p=%d, *q=%d\n", *p, *q);
} /* swap_p */

void c_pointer_fun(const int *p) {
  printf("[c_pointer_fun] *p = %d\n", *p);
  
  /* L'istruzione seguente causerebbe un errore */
  
  /* *p = 10; */

  /* Cosa succede se passiamo il puntatore a una 
     funzione che dichiara il parametro come const?
  */
  modify_pointer(p);
} /* c_pointer_fun */

void modify_pointer(int *p) {
  *p = 222;
} /* modify_pointer */

